<template>
  <v-app>
    <v-app-bar
      app
      dense
      color="black"
    >
      <div class="d-flex align-center">
        <v-img
          :src="require('./assets/reaper.png')"
          class="my-3"
          contain
          width="32"
        />
      </div>

       <v-text-field
        ref="search"
        v-model="search"
        flat
        hide-details
        dense
        solo
        prepend-inner-icon="mdi-magnify"
        label="Search"
        clearable
        class="mx-2"
        @keyup.enter="updateSearch"
      />
      <v-btn class="mr-2" @click="updateSearch"><v-icon class="pr-1">mdi-magnify</v-icon> Search</v-btn>
      <v-btn @click="exportCSV"><v-icon class="pr-2">mdi-folder-open-outline</v-icon> Export</v-btn>
      <v-checkbox class="px-2 pt-5" v-model="exact" label="Exact Matches"/>
    </v-app-bar>

    <v-main>
      <v-data-table
        class="mt-5 ml-2 mr-5"
        dense
        show-expand
        single-expand
        :expanded.sync="expanded"
        :loading="loading"
        :items-per-page='15'
        :headers="headers"
        :items="data"
      >
        <template #[`item.title`]="{item}">
         {{ truncate(item.title, 95) }}
        </template>
        <template #[`item.open`]="{item}">
          <v-btn
            class="mx-2"
            dark
            small
            icon
            rel="noopener noreferrer"
            target="_blank"
            :href="'http://'+item.ip"
          >
            <v-icon dark>
              mdi-open-in-new
            </v-icon>
          </v-btn>
        </template>
        <template v-slot:expanded-item="{ headers, item }">
          <td v-if="expanded[0] === item" :colspan="headers.length">
            <pre>
{{ index }}
            </pre>
          </td>
        </template>
      </v-data-table>
    </v-main>
  </v-app>
</template>

<script>
const axios = require('axios').default;
const ObjectsToCsv = require('objects-to-csv');

export default {
  name: 'App',
  methods: {
    async init() {
      this.loading = true;
      axios.get("http://127.0.0.1:3000/search", {params: {query: 'hello'}}).then(({data}) => {
        this.data = data;
        this.loading = false;
      });
    },
    async updateSearch() {
      this.loading = true;
      axios.get("http://127.0.0.1:3000/search", {params: {query: this.search}}).then(({data}) => {
        if(this.exact){
          this.data = data.filter((item) => item.title === this.search);
        } else {
          this.data = data
        }
        this.loading = false;
      }); 
    },
    async exportCSV(){
      const csv = new ObjectsToCsv(this.data);
      var blob = new Blob([await csv.toString()], { type: 'text/csv;charset=utf-8;' });
      if (navigator.msSaveBlob) { // IE 10+
        navigator.msSaveBlob(blob, 'export.csv');
      } else { // Other browsers, create a phantom element and then click it
        var link = document.createElement("a");
        if (link.download !== undefined) {
          var url = URL.createObjectURL(blob);
          link.setAttribute("href", url);
          link.setAttribute("download", 'export.csv');
          link.style.visibility = 'hidden';
          document.body.appendChild(link);
          link.click();
          document.body.removeChild(link);
        }
      }
    },
    getIndex(item){
      return axios.get(`http://127.0.0.1:3000/index?id=${item.id}`).then(response => response.data)
    },
    truncate(str, n){
      return (str.length > n) ? str.substr(0, n-1) + '...' : str;
    }
  },
  watch: {
    exact: function (newStatus) {
      if(newStatus) {
        this.loading = true;
        this.data = this.data.filter((item) => item.title === this.search);
        this.loading = false;
      } else {
        this.loading = true
        axios.get("http://127.0.0.1:3000/search", {params: {query: this.search}}).then(({data}) => {
          this.data = data
          this.loading = false;
        });
      }
    },
    expanded: function (newexpand) {
      if(newexpand[0]) {
        this.index = "";
         this.loading = true;
        axios.get(`http://127.0.0.1:3000/index?id=${newexpand[0].id}`).then(({data}) => {
          if(data[0]){
            if(data[0].files){
              this.index = data[0].files;
            } else {
              this.index = "Empty Directory";
            }
          } else {
            this.index = "No data.";
          }
          this.loading = false;
        })
        this.loading = false;
      } else {
        this.index = ""
      }
    }
  },
  mounted () {
    this.init();
  },
  data: () => ({
    loading: true,
    exact: true,
    search: '',
    index: '',
    expanded: [],
    headers: [
      {text: 'IP Address', align: 'start', sortable: true, value: 'ip', width: '10%'},
      {text: 'Title', sortable: true, value: 'title', width: '30%'},
      {text: 'City', sortable: true, value: 'city', width: '10%'},
      {text: 'Region', sortable: true, value: 'region'},
      {text: 'Country', sortable: true, value: 'country_name'},
      {text: 'Zip Code', sortable: true, value: 'postal'},
      {text: 'ASN', sortable: true, value: 'asn'},
      {text: 'Owner', sortable: true, value: 'asn_name'},
      {text: 'Open', sortable: false, value: 'open'}
    ],
    data: []
  }),
};
</script>
